<?php
namespace Customize\Twig\Extension;

use Twig\Extension\AbstractExtension;

class SampleExtention extends AbstractExtension
{
    /**
     * 拡張メソッドの一覧を返す
     */
    public function getFunctions()
    {
        return [
            new \Twig_Function('sample_method', [$this, 'sample_method'], ['is_safe' => ['all']]),
        ];
    }

    /**
     * 拡張メソッド
     */
    public function sample_method()
    {
        return "サンプル拡張です";
    }

    /**
     * 拡張フィルターの一覧を返す
     */
    public function getFilters()
    {
        return array(
            new \Twig_SimpleFilter('sample_filter', array($this, 'sample_filter')),
        );
    }

    /**
     * 拡張フィルター
     * $string ファイルターの対象が第一引数に渡される
     */
    public function sample_filter($string)
    {
        return $string ."フィルターを使用しました";
    }
}
