<?php
namespace Customize\EventListener;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\HttpKernel\Event\GetResponseForControllerResultEvent;
use Symfony\Component\HttpKernel\Event\FilterControllerEvent;
use Symfony\Component\HttpKernel\Event\FilterControllerArgumentsEvent;
use Symfony\Component\HttpKernel\Event\FilterResponseEvent;
use Symfony\Component\HttpKernel\Event\PostResponseEvent;
use Symfony\Component\HttpKernel\Event\FinishRequestEvent;
use Symfony\Component\HttpKernel\KernelEvents;

class SampleListener implements EventSubscriberInterface
{
    public function onKernelRequest(GetResponseEvent $event)
    {
        echo "onKernelRequest\n";
    }

    public function onKernelView(GetResponseForControllerResultEvent $event)
    {
        echo "onKernelView\n";
    }

    public function onKernelController(FilterControllerEvent $event)
    {
        echo "onKernelController\n";
    }

    public function onKernelControllerArguments(FilterControllerArgumentsEvent $event)
    {
        echo "onKernelControllerArguments\n";
    }

    public function onKernelResponse(FilterResponseEvent $event)
    {
        echo "onKernelResponse\n";
    }

    public function onKernelTerminate(PostResponseEvent $event)
    {
        echo "onKernelTerminate\n";
    }

    public function onKernelFinishRequest(FinishRequestEvent $event)
    {
        echo "onKernelFinishRequest\n";
    }

    /**
     * {@inheritdoc}
     */
    public static function getSubscribedEvents()
    {
        return [
            KernelEvents::REQUEST => [
                ['onKernelRequest', 6],
            ],
            KernelEvents::VIEW => [
                ['onKernelView', 6],
            ],
            KernelEvents::CONTROLLER => [
                ['onKernelController', 6],
            ],
            KernelEvents::CONTROLLER_ARGUMENTS => [
                ['onKernelControllerArguments', 6],
            ],
            KernelEvents::RESPONSE => [
                ['onKernelResponse', 6],
            ],
            KernelEvents::TERMINATE => [
                ['onKernelTerminate', 6],
            ],
            KernelEvents::FINISH_REQUEST => [
                ['onKernelFinishRequest', 6],
            ]
        ];
    }
}