<?php

namespace Customize\Controller;

use Eccube\Controller\AbstractController;
use Eccube\Entity\Page;
use Eccube\Entity\PageLayout;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Response;
use Eccube\Repository\PageRepository;
use Eccube\Repository\LayoutRepository;
use Eccube\Repository\PageLayoutRepository;

class SampleController extends AbstractController
{
    protected $pageRepository;

    protected $pageLayoutRepository;

    protected $layoutRepository;

    public function __construct(
        PageRepository $pageRepository,
        PageLayoutRepository $pageLayoutRepository,
        LayoutRepository $layoutRepository
    ) {
        $this->pageRepository = $pageRepository;
        $this->pageLayoutRepository = $pageLayoutRepository;
        $this->layoutRepository = $layoutRepository;
    }

    /**
     * @Method("GET")
     * @Route("/sample/index")
     * @Template("Sample/index.twig")
     */
    public function index()
    {
        // ȉ̃R[h͈xsĂ

        // Vdtb_pagepRepository쐬
        $Page = $this->pageRepository->newPage();

        // Urlsample_indexł͂Ȃcustomize_sample_index
        // fobOc[o[_routeȂǂŊmF\
        $Page->setUrl("customize_sample_index");

        // Twigt@C̊gqt@C
        $Page->setFileName("Sample/index");

        // y[W(C)
        $Page->setName("samplePage");

        // ǗTCgŒǉy[W(EDIT_TYPE_USER)AftHg̃y[W(EDIT_TYPE_DEFAULT)
        // ǗTCgŒǉy[W/user_data/tȂǋقȂ̂EDIT_TYPE_DEFAULTw肷
        $Page->setEditType(Page::EDIT_TYPE_DEFAULT);

        // f[^e[uɕۑ
        $this->entityManager->persist($Page);
        $this->entityManager->flush($Page);

        // ߑłdtb_layoute[uID2̃CAEg擾
        // ID2PC̉wy[WpCAEg
        $Layout = $this->layoutRepository->get(2);

        // dtb_page_layout̍Ō̃f[^擾
        $LastPageLayout = $this->pageLayoutRepository->findOneBy([], ['sort_no' => 'DESC']);
        $sortNo = $LastPageLayout->getSortNo();
        
        // ̃y[Wpdtb_page_layoutݒ
        $PageLayout = new PageLayout();
        $PageLayout->setLayoutId($Layout->getId());
        $PageLayout->setLayout($Layout);
        $PageLayout->setPageId($Page->getId());
        $PageLayout->setSortNo($sortNo++);
        $PageLayout->setPage($Page);

        $this->entityManager->persist($PageLayout);
        $this->entityManager->flush($PageLayout);

         return [];
    }
}